<dom-module id="sc-score">
    <template>
        <iron-signals on-iron-signal-move-image="scroll"></iron-signals>
        <iron-signals on-iron-signal-draw="track"></iron-signals>
        <iron-signals on-iron-signal-down="down"></iron-signals>
        <iron-signals on-iron-signal-select="tap"></iron-signals>
        <iron-signals on-iron-signal-click="cancel"></iron-signals>
        <iron-signals on-iron-signal-resize-content="resizeImage"></iron-signals>
        <iron-signals on-iron-signal-cancel="delete"></iron-signals>
        <svg id="zoom"></svg>
    </template>

    <script>

        Polymer({

            is:'sc-score',

            properties: {
                bg:String
            },

            attached: function() {
                var self = this;
                self.img = new Image();
                self.img.src = self.bg;
                self.img.addEventListener("load",function(){
                    var height = this.naturalHeight;
                    var width = this.naturalWidth;
                    self.img.width = this.naturalWidth;
                    self.img.height = this.naturalHeight;
                    var size = self.getSize(self.img.height,self.img.width,window.innerHeight);
                    self.paper = new Paper(size["width"],size["height"]);
                    self.paper.attachImg(this.src,"detail");
                });
            },

            getSize:function(h,w,windowHeight) {
                var height = h;
                var width = w;
                if (height > windowHeight) {
                    height = windowHeight;
                    width /= (h/height);
                }
                return {height,width};
            },

            tap: function(event,detail) {
                this.paper.selectCurrent();
            },

            down:function(event,detail) {
                event.preventDefault();
                this.paper.createGlab(detail.x,detail.y);
            },
            
            track: function(event,detail) {
                event.preventDefault();
                if (detail.id == "detail") {
                    this.paper.drawGlab(detail.w,detail.h,detail.startX);  
                }             
            },

            scroll : function(event,detail) {
                event.preventDefault();
                if (detail.frame) {
                    this.paper.scrollImg(detail.x);
                }
                else {
                    this.paper.moveImg(detail.x,0);
                }
            },

            resizeImage: function(event,detail) {
                var height = this.img.height;
                var width = this.img.width; 
                var size = this.getSize(height,width,detail.windowHeight);
                this.paper.resize(size["width"],size["height"]);
            },

            cancel: function(event) {
                this.paper.stopSelection();
            },

            delete: function(event) {
                this.paper.removeGlab();
            }

        })
    </script>
</dom-module>